// BEZİER EĞRİSİ
// HAZIRLAYAN: ÖĞR. GÖR. UFUK ŞANVER
// FARENİN SAĞ TIKLAMASI İLE 1. NOKTA, SOL TIKLAMASI İLE 2. NOKTANIN KOORDİNATI
// DEĞİŞTİRİLİR
// KODA TEŞKİL EDEN KAYNAK, PROF. DR. RIFAT YAZICI DERS NOTLARI
//Projeye sağ tıklayıp ilgili Bağlayıcıların (Linker) ekli olduğunu kontrol ediniz.
#include <GL/freeglut.h>
#include <math.h>
#include <cmath>
#include <ctime>
#include <iostream>
#include <vector>


std::vector <float> vvx;
std::vector <float> vvy;
float nokta1x = 2.0;
float nokta1y = 3.0;
float nokta2x = 4.0;
float nokta2y = 3.0;
float X2 = 20.0;
float Y2 = 15.0;
int ekranen = 800;
int ekranboy = 600;
float mavi = 0.0;
float yesil = 0.0;
float kirmizi = 1.0;
int say = 0;
long faktoryal(short sayi) {
	long donus = 1;
	short sayac;
	if (sayi >= 2) {
		for (sayac = sayi;sayac > 1;sayac--) {
			donus = donus * sayac;
		}
	}
	return donus;
}
long kombinasyon(short n, short i) {
	long kombi = 0;
	kombi = faktoryal(n) / (faktoryal(i) * faktoryal(n - i));
	return kombi;
}

double JJ(short n, short i,float t) {
	double donus = 0.0;
	donus = kombinasyon(n, i) * pow(t, i) * pow((1 - t), (n - i));
	return donus;
}

void init (void)
{
 float deger=0;
  glClearColor(0.0, 1.0, 0.0, 0.0);
  glMatrixMode(GL_PROJECTION); 
  gluOrtho2D(0.0, X2, 0.0, Y2); //X1,X2,Y1,Y2
  deger=cos(1.75);  
}

void bezierciz() {
	float a = 4.0;
	float tx = 0.0;
	short sayac = 0;
	double noktax = 0.0;
	double noktay = 0.0;
	double oncekix = 0.0;
	double oncekiy = 0.0;
	double J[4] = { 0.0,0.0,0.0,0.0 };
	double P[4][2];
	double PP[4][2];
	P[0][0] = 1.0;
	P[0][1] = 8.0;
	P[1][0] = nokta1x;
	P[1][1] = nokta1y;
	P[2][0] = nokta2x;
	P[2][1] = nokta2y;
	P[3][0] = 15.0;
	P[3][1] = 8.0;
	PP[0][0] = 1.0 * 2.0 + 2.0;
	PP[0][1] = 1.0 * 2.0 + 2.0;
	PP[1][0] = 2.0 * 3.0 + 2.0;
	PP[1][1] = 3.0 * 3.0 + 2.0;
	PP[2][0] = 4.0 * 4.0 + 2.0;
	PP[2][1] = 3.0 * 4.0 + 2.0;
	PP[3][0] = 3.0 * 2.0 + 2.0;
	PP[3][1] = 1.0 * 2.0 + 2.0;
	glClear(GL_COLOR_BUFFER_BIT);
	glColor3f(0.0, 0.0, 0.0);
	
	glBegin(GL_LINE_STRIP);
	for (tx = 0.00;tx <=1.0;tx+=0.01) {
		J[0] = JJ(3, 0, tx);
		J[1] = JJ(3, 1, tx);
		J[2] = JJ(3, 2, tx);
		J[3]= JJ(3, 3, tx);
		noktax = P[0][0] * J[0] + P[1][0] * J[1] + P[2][0] * J[2] + P[3][0] * J[3];
		noktay = P[0][1] * J[0] + P[1][1] * J[1] + P[2][1] * J[2] + P[3][1] * J[3];
		glVertex2d(noktax, noktay);
	}
	glEnd();
	

	glPointSize(8);
	glColor3f(0.0, 0.0, 1.0);
	glBegin(GL_POINTS);
	for (sayac = 0;sayac < 4;sayac++) {
		glVertex2d(P[sayac][0], P[sayac][1]);
	}
	glEnd();

	


	
	if (say == 0) {
		glPointSize(8);
		glColor3f(1.0, 0.0, 0.0);
		glBegin(GL_POINTS);
		for (sayac = 0;sayac < vvx.size();sayac++) {
			glVertex2d(vvx[sayac], vvy[sayac]);
		}
		glEnd();
	}
	else {
		glPointSize(8);
		glColor3f(1.0, 0.0, 0.0);
		glBegin(GL_POINTS);
		for (sayac = 0;sayac <say;sayac++) {
			glVertex2d(vvx[sayac], vvy[sayac]);
		}
		glEnd();

			glColor3f(0.0, 0.0, 1.0);
			glBegin(GL_POINTS);
		for (sayac = say;sayac < vvx.size();sayac++) {
			glVertex2d(vvx[sayac], vvy[sayac]);
		}
		glEnd();
	}
	

	glFlush();
	glutPostRedisplay();
}


void mouse(int btn, int state, int x, int y)
{
	if (btn == GLUT_RIGHT_BUTTON && state == GLUT_DOWN) {
			printf("\n nokta1x=%d",x);
		nokta1x = x * (X2 / ekranen);
			printf("\n nokta1y=%d",y);
		nokta1y = Y2 - y * (Y2 / ekranboy);

	}

	if (btn == GLUT_LEFT_BUTTON && state == GLUT_DOWN) {
		printf("\n nokta2x=%d", x);
		printf("\n nokta2y=%d", y);
		nokta2x = x* (X2/ekranen);
		nokta2y = Y2 - y*(Y2/ekranboy);
	}
	glTranslatef(0.0, 0.0, 0.0);
}

void keyInput(unsigned char key, int x, int y)
{
	switch (key)
	{
	case 27:
		exit(0);
		break;
	case 'Y':
		say = vvx.size();
		kirmizi = 0.0;
		mavi = 0.0;
		yesil = 1.0;
		glutPostRedisplay();
		break;
	case 'M':
		say = vvx.size();
		printf("\n say= %d", say);
		kirmizi = 0.0;
		mavi = 1.0;
		yesil = 0.0;
		glutPostRedisplay();
		break;
	default:
		break;
	}
}
int main(int argc, char** argv)
{
 // glutInit(&argc, argv);
	long a=100;
	long a1 = 200;
		glutInit(&argc, argv);
		glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
		glutInitWindowPosition(150, 150);
		glutInitWindowSize(ekranen, ekranboy);
		glutCreateWindow("Istanbul Ticaret Universitesi Bilgisayar Grafikleri Dersi ");
		init();
	
		glutDisplayFunc(bezierciz);
		glutKeyboardFunc(keyInput);
		glutMouseFunc(mouse);

		glutMainLoop();
	
		return 0;       /* ANSI C requires main to return int. */
	
	

}

